(function($) {

	'use strict';

	var authorize_loaded_#form_instance_id = false;
	var authorize_amount_#form_instance_id = 0;

	if(
		(authorize_loaded_#form_instance_id === false)
	) {
		var js_prefix = ('#action_authorizeaccept_environment' == 'sandbox') ? 'jstest' : 'js';

		// Request checkout.js
		$.getScript('https://' + js_prefix + '.authorize.net/v3/AcceptUI.js', function() {

			authorize_init_#form_instance_id();
		});

		authorize_loaded_#form_instance_id = true;

	} else {

		// Do not load checkout.js twice
		authorize_init_#form_instance_id();
	}

	function authorize_message_#form_instance_id(message, type) {

		var method = '#action_authorizeaccept_message_method';
		var form_hide = '#action_authorizeaccept_message_form_hide';
		var duration = '#action_authorizeaccept_message_duration';
		var clear = '#action_authorizeaccept_message_clear';
		var scroll_top = '#action_authorizeaccept_message_scroll_top';

		window.wsf_form_instances[#form_instance_id].action_message(message, type, method, duration, form_hide, clear, scroll_top, true, true);
	}

	// Click handler
	$('##id').click(function(e) {

		e.preventDefault();

		// Clear descriptor and value
		$('##id_descriptor').val('');
		$('##id_value').val('');

		window.wsf_form_instances[#form_instance_id].log('log_payment', 'Authorize Accept - Clicked', 'payment');

		// Check if form is valid
		if(!window.wsf_form_instances[#form_instance_id].form_valid) {

			// Form is not valid, so submit it to simulate validation
			window.wsf_form_instances[#form_instance_id].form_obj.submit();
			return false;
		}

		// Check amount
		var authorize_total = authorize_get_amount_total_#form_instance_id();

		if(authorize_total == 0) {

			// Process as zero amount
			switch('#action_authorizeaccept_transaction_zero') {

				// Submit form
				case 'submit' :

					window.wsf_form_instances[#form_instance_id].form_obj.submit();
					break;

				// Show message
				case 'message' :

					var message = '#action_authorizeaccept_transaction_zero_message';
					authorize_message_#form_instance_id(message, 'danger');
					break;
			}

			return false;
		}

		// Open Authorize Accept iframe
		$('##id_trigger').trigger('click');
	});

	// Get amount total
	function authorize_get_amount_total_#form_instance_id() {

		var transaction_total = '#action_authorizeaccept_transaction_amount';
		if(transaction_total == '') { transaction_total = '#ecommerce_cart_total'; }

		// Get Authorize total
		var authorize_total = window.wsf_form_instances[#form_instance_id].parse_variables_process(transaction_total).output;

		// Convert to a number
		authorize_total = window.wsf_form_instances[#form_instance_id].get_number(authorize_total);

		// Store for use later
		authorize_amount_#form_instance_id = authorize_total;

		return authorize_total;
	}

	// Response handler
	window['authorize_response_handler_#form_instance_id'] = function(response) {

		// Process messages
		if(typeof(response.messages) !== 'undefined') {

			var result_code = response.messages.resultCode;

			switch(result_code) {

				// Successful
				case 'Ok' :

					// Set descriptor and value
					$('##id_descriptor').val(response.opaqueData.dataDescriptor);
					$('##id_value').val(response.opaqueData.dataValue);

					// Get total amount of transaction
					var amount = authorize_amount_#form_instance_id;

					// Log
					window.wsf_form_instances[#form_instance_id].log('log_payment', 'Authorize Accept - Response Received', 'payment');

					// Set payment method
					window.wsf_form_instances[#form_instance_id].form_ecommerce_set_payment_method('Authorize Accept');

					// Set payment amount (Overrides calculated amount in case the payment button has a fixed value, we always want to show the processed amount in submissions)
					window.wsf_form_instances[#form_instance_id].form_ecommerce_set_payment_amount(amount);

					// Submit the form and run actions
					window.wsf_form_instances[#form_instance_id].form_obj.submit();

					break;

				// Error handling
				case 'Error' :

					// Clear descriptor and value
					$('##id_descriptor').val('');
					$('##id_value').val('');

					var message_array = response.messages.message;

					for(var message_index in message_array) {

						var message = message_array[message_index];

						var message_string = message.code + ': ' + message.text;

						// Process JS action message
						authorize_message_#form_instance_id(message_string, 'danger');

						window.wsf_form_instances[#form_instance_id].log('log_payment', 'Authorize Checkout - Closed', 'payment');
						window.wsf_form_instances[#form_instance_id].form_ecommerce_set_status('cancelled');
					}
					break;
			}
		}
	}

	function authorize_init_#form_instance_id() {

		window.wsf_form_instances[#form_instance_id].log('log_payment', 'Authorize Accept - Payment Initiated', 'payment');

		window.wsf_form_instances[#form_instance_id].form_ecommerce_set_status('pending_payment');
	}

})(jQuery);
